MAXScript Language Reference > 3ds Max Objects > TextureMap : Material > TextureMap Types >

# Raytrace : TextureMap

    Raytrace - superclass: textureMap; super-superclass:material - classID: #(0, 675561916)

Value > MAXWrapper > Material > TextureMap > Raytrace

| Materials and Maps - Quick Navigation

Constructor

    raytrace...

Properties

    <Raytrace.parameters>.Trace_Mode Integer default: 0

Sets whether to cast reflected or refracted rays:

0- Auto Detect (If assigned to the material’s Reflection component, the raytracer will reflect. If assigned to Refraction, it will refract. If you assign Raytrace to any other component, you have to manually specify whether you want reflected rays or refracted rays.)

1- Reflection (Casts reflected rays off the object’s surface.)

2- Refraction (Casts refracted rays into or through the object’s surface.)

    <Raytrace.parameters>.Options__Raytracer_Enable Boolean default: true -- animatable

Turns the raytracer on or off.

Even with raytracing off, Raytrace material and Raytrace map still reflect and refract the environment, including both the environment map for the 3ds Max scene, and the environment map assigned to the Raytrace material.

    <Raytrace.parameters>.Options__Antialiasing_Enable Boolean default: true -- animatable

Turns anti-aliasing on or off.

Anti-aliasing is possibly the slowest portion of raytrace rendering.

    <Raytrace.parameters>.Options__Self_Reflect_Refract Boolean default: true -- animatable

Turns self reflection/refraction on or off.

    <Raytrace.parameters>.Options__Raytrace_Atmospherics Boolean default: true -- animatable

Turns the raytracing of atmospheric effects on or off.

Atmospheric effects include fire, fog, volume light, and so on.

    <Raytrace.parameters>.Options__Reflect_Refract_Material_ID_s Boolean default: true -- animatable

When on, the material reflects effects assigned to material IDs in the renderer’s G-buffer on or off.

    <Raytrace.parameters>.Options__Raytrace_Objects_in_Glass Boolean default: true -- animatable

Turns the raytracing of objects inside raytraced objects on or off.

    <Raytrace.parameters>.Options__Raytrace_Atmospherics_in_Glass Boolean default: true -- animatable

Same as the previous control, but for atmospheric effects instead of objects.

    <Raytrace.parameters>.Options__Color_Density___Fog_Enable Boolean default: true -- animatable

Turns the color density and fog features on or off.

    <Raytrace.parameters>.Background_Mode Integer default: 0

Sets Background Mode:

0- Use Environment Settings (Respects the environment settings of the current scene.)

1- Use Background_Color (Overrides environment settings)

2- Use background map (Overrides the environment settings with the specified map.)

    <Raytrace.parameters>.Background_Color Color default: (color 0 0 0) -- animatable

Color used as background.

    <Raytrace.parameters>.Local_Antialias_Override Boolean default: false

When on, allows you to modify local anitialiasing settings.

    <Raytrace.parameters>.Adaptive_Antialiasing Boolean default: false

When on, enables the adaptive antialiaser for this Raytrace map.

    <Raytrace.parameters>.Local_Threshold Float default: 0.1 -- animatable

Determines the sensitivity of the adaption algorithm.

This value can range from 0 to 1, where 0 always casts the maximum number of rays and 1 always casts only the minimum number of rays.

    <Raytrace.parameters>.Local_Min__Rays Integer default: 4 -- animatable

Sets the initial number of rays cast per pixel.

    <Raytrace.parameters>.Local_Max_Rays Integer default: 32 -- animatable

Sets the maximum number of rays the algorithm casts.

    <Raytrace.parameters>.Local_Blur_Offset Float default: 0.0 -- animatable

Affects the sharpness or blurriness of reflections or refractions without regard to distance.

You can use this to soften the details of a reflection or refraction.

This value is specified in pixels.

    <Raytrace.parameters>.Local_Blur_Aspect Float default: 1.0 -- animatable

Changes the shape of the blur by changing the aspect ratio. Usually you will not need to change this setting.

    <Raytrace.parameters>.Local_Defocus_Amount Float default: 0.0 -- animatable

Blurs based on distance.

Objects near the surface are not blurred, but objects farther away are blurred.

The rays cast are spread as they leave the surface of the Raytrace map object.

    <Raytrace.parameters>.Local_Defocus_Aspect Float default: 1.0 -- animatable

Changes the shape of the defocusing by changing the aspect ratio. Usually you will not need to change this setting.

    <Raytrace.parameters>.Use_Blur_Map Boolean default: false

When on, uses a map to apply the Blur Offset value. That is, where the map is white, blur offset is fully applied, and where it is black, it is ignored.

For example, if the map is a Checker map, blur offset is applied only in every other square.

Values between black and white cause less blur.

    <Raytrace.parameters>.Use_Defocus_Map Boolean default: false

When on, uses a map to apply the Defocus value. That is, where the map is white, Defocus is fully applied, and where it is black, it is ignored.

For example, if the map is a Checker map, Defocus is applied only in every other square.

Values between black and white cause less defocusing.

    <Raytrace.parameters>.Attenuation_Mode Integer default: 0

Sets Attenuation Mode:

0- Off

1- Linear (Linear attenuation is calculated between the attenuation_start and attenuation_end values.)

2- Inverse Scale (Sets inverse square attenuation. Inverse square attenuation is calculated beginning at the attenuation_start range, and doesn’t use the attenuation_end range. Inverse scale is the actual attenuation rate for light in the real world. However, it doesn’t always give the effect you want in a rendered scene.)

3- Exponential (Sets exponential attenuation. Exponential attenuation is calculated between the attenuation_start and attenuation_end values. You also specify the exponent to use.)

4- Custom Falloff (Specifies a custom curve to use for attenuation.)

    <Raytrace.parameters>.Attenuation_Start Float default: 0.0 -- animatable

The distance in world units where attenuation begins.

    <Raytrace.parameters>.Attenuation_End Float default: 100.0 -- animatable

The distance in world units where attenuation ends.

    <Raytrace.parameters>.Attenuation_Exponent Float default: 2.0 -- animatable

The attenuation exponent.

    <Raytrace.parameters>.Attenuation_Color_Mode Integer default: 0

Controls the Attenuation Color mode.

Possible values are:

0 - Background;

1 - use Attenuation_Color

    <Raytrace.parameters>.Attenuation_Color Color default: (color 0 0 0) -- animatable

Sets the distance in world units where the ray is fully attenuated.

    <Raytrace.parameters>.Attenuation_Near Float default: 1.0 -- animatable

Sets the strength of the reflected/refracted ray at the start range distance.

This is a normalized percentage that can range from 0.0 to 1.0.

    <Raytrace.parameters>.Attenuation_Control_1 Float default: 0.6666 -- animatable

Controls the shape of the curve near the curve start.

    <Raytrace.parameters>.Attenuation_Control_2 Float default: 0.3333 -- animatable

Controls the shape of the curve near the curve end.

    <Raytrace.parameters>.Attenuation_Far Float default: 0.0 -- animatable

Sets the strength of the reflected/refracted ray at the end range distance.

This is a normalized percentage that can range from 0.0 to 1.0.

    <Raytrace.parameters>.Use_Reflectivity_Map Boolean default: false -- animatable

Enables a reflectivity map.

    <Raytrace.parameters>.Reflectivity_Map_Amount Float default: 1.0 -- animatable

Controls the amount of raytracing used by the material it is assigned to.

    <Raytrace.parameters>.Basic_Tint_Enable Boolean default: false

Turns basic tinting on or off.

    <Raytrace.parameters>.Tint_Amount Float default: 1.0 -- animatable

Sets the amount of tinting used.

    <Raytrace.parameters>.Tint_Color Color default: (color 255 255 255) -- animatable

Assigns a tint color for reflections.

    <Raytrace.parameters>.Use_Tint_Map Boolean default: false

Enables the use of a map for tinting.

    <Raytrace.parameters>.Color_Density_Enable Boolean default: false

Turns color density on or off.

    <Raytrace.parameters>.Color_Density_Color Color default: (color 255 255 255) -- animatable

Sets the transmission color.

    <Raytrace.parameters>.Color_Density_Amount Float default: 1.0 -- animatable

Controls the amount of density color.

It can range from 0 to 1.0.

Reducing this value reduces the density color effect.

    <Raytrace.parameters>.Color_Density_Start Float default: 0.0 -- animatable

    <Raytrace.parameters>.Color_Density_End Float default: 25.0 -- animatable

A thin piece of tinted glass is mainly clear, while a thick piece of the same glass has more color.

Start and End Distance, expressed in world units, controls help you simulate this effect.

Start is the position in the object where the density color begins to appear.

End is the position in the object where the density color reaches its full Amount value.

To have a lighter effect, increase the End value.

To have a heavier effect, reduce the End value.

    <Raytrace.parameters>.Use_Color_Density_Map Boolean default: false

Enables the use of a map for the color density filter.

    <Raytrace.parameters>.Fog_Enable Boolean default: false

Turns fog on or off.

    <Raytrace.parameters>.Fog_Color Color default: (color 255 255 255) -- animatable

Sets the fog color.

    <Raytrace.parameters>.Fog_Amount Float default: 1.0 -- animatable

Controls the amount of density fog. It can range from 0 to 1.0.

Reducing this value reduces the density fog effect and makes the fog translucent.

    <Raytrace.parameters>.Fog_Start Float default: 0.0 -- animatable

    <Raytrace.parameters>.Fog_End Float default: 25.0 -- animatable

Start and End Distance controls, expressed in world units, adjust the fog effect based on the object’s dimensions.

Start is the position in the object where the density fog begins to appear.

End is the position in the object where the density fog reaches its full Amount value.

To have a lighter effect, increase the End value.

To have a heavier effect, reduce the End value.

    <Raytrace.parameters>.Use_Fog_Map Boolean default: false

Enables a map for the fog color.

    <Raytrace.parameters>.Bump_Multiplier Float default: 0.2 -- float

Get/set the Bump Multiplier value.

    <Raytrace.parameters>.Filter_Density_Map_Amount Float default: 1.0 -- float

Get/set the Filter Density map amount value.

    <Raytrace.parameters>.Fog_Map_Amount Float default: 1.0 -- float

Get/set the Fog map amount value.

    <Raytrace.parameters>.Refractions_as_Glass_Enable Boolean default: true -- boolean

Enable the glass refractions option.

    <Raytrace.parameters>.Tint_Map_Amount Float default: 1.0 -- float

Get/set the Tint map amount value.

The following properties do not correspond to any user-interface items, and may or may not be used by the raytracer.

    <Raytrace.parameters>.Interobject_Interphase_Fusing Boolean default: false

    <Raytrace.parameters>.IIF_Tolerance Float default: 1.0

    <Raytrace.parameters>.Options__Color_Density___Fog_Enable Boolean default: true -- animatable; boolean

NoteThe sub-maps that can be assigned to a Raytrace texturemap are not accessible to MAXScript unless they have already been assigned to the Bricks map. Once these maps have been assigned, they are available as properties of the Bricks TextureMap value. The property names, however, are dependent on the type of maps assigned. For example, if dent maps were assigned to all the sub-maps, the property names would be similar to Background__Map__17____Dent , Blur_Map__Map__18____Dent , Defocus_Map__Map__19____Dent , Reflectivity_Map__Map__20____Dent , Tint_Map__Map__21____Dent , Color_Density_Map__Map__22____Dent , and Fog_Color_Map__Map__23____Dent . These maps are also stored as subAnims 2 through 8 of the Raytrace TextureMap value, respectively. If the subAnim name for a subAnim is similar to Background__None , no map has been assigned to that sub-map.

#### See Also

- TextureMap Common Properties, Operators, and Methods

- Material Common Properties, Operators, and Methods

- MAXWrapper Common Properties, Operators, and Methods

- Value Common Properties, Operators, and Methods